%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

char *me;

void stexts(char *text) {
    ss_scan_string(text);
}

void setmyname(char *myname) {
    me=myname;
}

void display_current_datetime(char *format) {
    time_t tt = time(NULL);
    struct tm *ts;
    char str[64];
    ts=localtime(&tt);
    strftime(str, sizeof(str), format, ts);
    printf("%s", str);
}

%}

%option prefix="ss"
%option noyywrap

ME <ME>
DATE <DATE>
TIME <TIME>
%%
{ME}    printf("%s", me);
{DATE}  display_current_datetime("%Y/%m/%d");
{TIME}  display_current_datetime("%H:%M:%S");
%%

#ifdef STANDALONE
int main(int argc, char *argv[])
{
    me = "おいら";
    int i;
    char *text="これは、文字列変換の実験。今日は、<DATE>。そして時刻は、<TIME>。わたしの名前は「<ME>」です。\n<ME>は、いつも元気で前向きです。\nあなたの名前も<ME>ですか。\n";
    ss_scan_string(text);
    sslex();
}

void sserror (const char *s) {
   fprintf (stderr, "%s\n", s);
}
#endif

